<?php

/*
 * Plugin Name:       GDPR Map
 * Plugin URI:        https://www.gdpr-map.eu/
 * Description:       GDPR ready maps plugin
 * Version:           0.9.3
 * Requires at least: 5.2
 * Requires PHP:      7.2
 * Author:            stdout UG
 * Author URI:        https://www.stdout.company/
 * Text Domain:       gdprmap
 */

require_once("includes/maps-main.php");
require_once("includes/maps-settings.php");
require_once("includes/maps-backend.php"); 
require_once("includes/maps-frontend.php");


/*
 * register plugin wizzard
 */

add_action( "admin_init", function(){

    // disable wizard on click
    if( isset($_GET['gdprmapwizard']) ) {

        if( $_GET['gdprmapwizard'] == 'true' ) {
            update_option( "gdprmap_show_wizard", 0 );
            return;
        }
    }

    // show wizard
    if ( get_option( $opt_name = "gdprmap_show_wizard" ) ) {
        add_action( "admin_notices", "gdprmap_wizard_notice" );
    } return;
});


/*
 * wizzard notice html
 */
function gdprmap_wizard_notice() {

    ?>

    <div class="updated notice is-dismissible">
        <p>Welcome to GDPR Map! You are just a few steps away from getting ready.</p>
        <p><a href="options-general.php?page=gdprmapsettings&gdprmapwizard=true" class="button button-primary">Run wizard</a></p>
    </div>

    <?php

}


/*
 * init options
 */
register_activation_hook( __FILE__, function() {

    if( empty( get_option( 'gdprmap_options' ) ) ) {

        update_option( "gdprmap_show_wizard", 1 );
        update_option( "gdprmap_options", "" );
    }
    
});
