<?php

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

/**
 *  add metabox to gdprmap content type
 */
add_action( 'add_meta_boxes_gdprmap', 'gdprmap_add_metabox' );
function gdprmap_add_metabox() {

	add_meta_box(
		'gdprmap_settings_metabox', // metabox ID
		'Map settings', // title
		'gdprmap_settings_metabox_callback', // callback function
		'gdprmap', // add meta box to custom post type (or post types in array)
		'normal', // position (normal, side, advanced)
		'high' // priority (default, low, high, core)
	);

	add_meta_box(
		'gdprmap_metabox', // metabox ID
		'Map and marker', // title
		'gdprmap_metabox_callback', // callback function
		'gdprmap', // add meta box to custom post type (or post types in array)
		'normal', // position (normal, side, advanced)
		'low' // priority (default, low, high, core)
	);

}

 
/**
 *  add metabox content
 */
function gdprmap_settings_metabox_callback( $post ) {

	// options
	$gdprmap_width = get_post_meta( $post->ID, 'gdprmap_width', true );
	$gdprmap_height = get_post_meta( $post->ID, 'gdprmap_height', true );
	$gdprmap_width_unit = get_post_meta( $post->ID, 'gdprmap_width_unit', true );
	$gdprmap_height_unit = get_post_meta( $post->ID, 'gdprmap_height_unit', true );
	$gdprmap_center = get_post_meta( $post->ID, 'gdprmap_center', true );
	$gdprmap_zoom = get_post_meta( $post->ID, 'gdprmap_zoom', true );
	$gdprmap_scroll = get_post_meta( $post->ID, 'gdprmap_scroll', true );
	$gdprmap_fixed_map = get_post_meta( $post->ID, 'gdprmap_fixed_map', true );
	$gdprmap_zoom_controll = get_post_meta( $post->ID, 'gdprmap_zoom_controll', true );
	$gdprmap_fullscreen_controll = get_post_meta( $post->ID, 'gdprmap_fullscreen_controll', true );
	$gdprmap_doubleclick = get_post_meta( $post->ID, 'gdprmap_doubleclick', true );
	$gdprmap_searchbox = get_post_meta( $post->ID, 'gdprmap_searchbox', true );
	$gdprmap_geolocator = get_post_meta( $post->ID, 'gdprmap_geolocator', true );
	$gdprmap_pitch = get_post_meta( $post->ID, 'gdprmap_pitch', true );
	$gdprmap_bearing = get_post_meta( $post->ID, 'gdprmap_bearing', true );
	$gdprmap_style = get_post_meta( $post->ID, 'gdprmap_style', true );

	if( empty($gdprmap_width) ) {
		$gdprmap_width = "1000";
	}

	if( empty($gdprmap_height) ) {
		$gdprmap_height = "400";
	}

	if( empty($gdprmap_zoom) ) {
		$gdprmap_zoom = "0";
	}

	if( empty($gdprmap_style) ) {
		$gdprmap_style = 'osm-bright-gl-style';
	}


	$gdprmap_width_unit_lookup[$gdprmap_width_unit] = " selected";
	$gdprmap_height_unit_lookup[$gdprmap_height_unit] = " selected";

	?>

	<table id="gdprmap-manual-entry" class="form-table">
		<tbody>
			<tr>
				<td>
					<table>
						<tr>
							<th><label for="gdprmap_width">width <span class="gdpr-tooltip">*<span class="gdpr-tooltiptext">changes are made to the frontend only</span></span></label></th>
							<td><input type="text" id="gdprmap_width" name="gdprmap_width" value="<?php echo esc_attr( $gdprmap_width ) ; ?>" class="regular-text"> <select name="gdprmap_width_unit"><option value="px"<?php echo $gdprmap_width_unit_lookup['px']; ?>>px</option><option value="%"<?php echo $gdprmap_width_unit_lookup['%']; ?>>%</option><option value="em"<?php echo $gdprmap_width_unit_lookup['em']; ?>>em</option><option value="vw"<?php echo $gdprmap_width_unit_lookup['vw']; ?>>vw</option></select></td>
						</tr>
						<tr>
							<th><label for="gdprmap_height">height <span class="gdpr-tooltip">*<span class="gdpr-tooltiptext">changes are made to the frontend only</span></span></label></th>
							<td><input type="text" id="gdprmap_height" name="gdprmap_height" value="<?php echo esc_attr( $gdprmap_height ) ; ?>" class="regular-text"> <select name="gdprmap_height_unit"><option value="px"<?php echo $gdprmap_height_unit_lookup['px']; ?>>px</option><option value="%"<?php echo $gdprmap_height_unit_lookup['%']; ?>>%</option><option value="em"<?php echo $gdprmap_height_unit_lookup['em']; ?>>em</option><option value="vh"<?php echo $gdprmap_height_unit_lookup['vh']; ?>>vh</option></select></td>
						</tr>
						<tr>
							<th><label for="gdprmap_center">center</label></th>
							<td><input type="text" id="gdprmap_center" name="gdprmap_center" value="<?php echo esc_attr( $gdprmap_center ) ; ?>" class="regular-text"></td>
						</tr>
						<tr>
							<th><label for="gdprmap_zoom">zoom</label></th>
							<td><input type="text" id="gdprmap_zoom" name="gdprmap_zoom" value="<?php echo esc_attr( $gdprmap_zoom ) ; ?>" class="regular-text"></td>
						</tr>
						<tr>
							<th><label for="gdprmap_pitch">pitch</label></th>
							<td><input type="text" id="gdprmap_pitch" name="gdprmap_pitch" value="<?php echo esc_attr( $gdprmap_pitch ) ; ?>" class="regular-text"></td>
						</tr>
						<tr>
							<th><label for="gdprmap_bearing">bearing</label></th>
							<td><input type="text" id="gdprmap_bearing" name="gdprmap_bearing" value="<?php echo esc_attr( $gdprmap_bearing ) ; ?>" class="regular-text"></td>
						</tr>
						<tr>
							<th></th>
							<td><button class="button button-primary button-large" onClick="gdprmap_center_map();return false;">apply</button></td>
						</tr>
					</table>
				</td>
				<td>
					<table>
						<tr>
							<th><label for="gdprmap_doubleclick">enable doubleclick zoom</label></th>
							<td><input type="checkbox" id="gdprmap_doubleclick" name="gdprmap_doubleclick" value="true" <?php echo checked( "true", $gdprmap_doubleclick, false ) ; ?> class="regular-text"></td>
						</tr>
						<tr>
							<th><label for="gdprmap_scroll">disable scroll wheel</label></th>
							<td><input type="checkbox" id="gdprmap_scroll" name="gdprmap_scroll" value="true" <?php echo checked( "true", $gdprmap_scroll, false ) ; ?>></td>
						</tr>
						<tr>
							<th><label for="gdprmap_zoom_controll">disable zoom controll</label></th>
							<td><input type="checkbox" id="gdprmap_zoom_controll" name="gdprmap_zoom_controll" value="true" <?php echo checked( "true", $gdprmap_zoom_controll, false ) ; ?>></td>
						</tr>
						<tr>
							<th><label for="gdprmap_fullscreen_controll">enable fullscreen</label></th>
							<td><input type="checkbox" id="gdprmap_fullscreen_controll" name="gdprmap_fullscreen_controll" value="true" <?php echo checked( "true", $gdprmap_fullscreen_controll, false ) ; ?>></td>
						</tr>
						<tr>
							<th><label for="gdprmap_fixed_map">fixed map <span class="gdpr-tooltip">*<span class="gdpr-tooltiptext">changes are made to the frontend only</span></span></label></th>
							<td><input type="checkbox" id="gdprmap_fixed_map" name="gdprmap_fixed_map" value="true" <?php echo checked( "true", $gdprmap_fixed_map, false ) ; ?>></td>
						</tr>
						<tr>
							<th><label for="gdprmap_searchbox">show searchbox <span class="gdpr-tooltip">*<span class="gdpr-tooltiptext">changes are made to the frontend only</span></span></label></th>
							<td><input type="checkbox" id="gdprmap_searchbox" name="gdprmap_searchbox" value="true" <?php echo checked( "true", $gdprmap_searchbox, false ) ; ?>></td>
						</tr>
						<tr>
							<th><label for="gdprmap_geolocator">show geolocator</label></th>
							<td><input type="checkbox" id="gdprmap_geolocator" name="gdprmap_geolocator" value="true" <?php echo checked( "true", $gdprmap_geolocator, false ) ; ?>></td>
						</tr>
					</table>
				</td>
			</tr>
		</tbody>
	</table>

	<input type="hidden" id="gdprmap_style" name="gdprmap_style" value="<?php echo $gdprmap_style; ?>">

	<?php
}


/**
 *  add metabox content
 */
function gdprmap_metabox_callback( $post ) {

	// include js and css
	gdprmap_include_js_css();
	wp_enqueue_style( 'wp-color-picker' );
	wp_enqueue_script('wp-tinymce');
	wp_enqueue_script('gdpr-map-admin', plugin_dir_url( __DIR__ ) . 'js/admin.js', array('jquery', 'wp-color-picker'), false, array('in_footer' => true) );
	wp_enqueue_style('gdpr-map-admin', plugin_dir_url( __DIR__ ) . 'css/admin.css');

	wp_add_inline_script( 'gdpr-map-admin', 'const GDPRMAP = ' . json_encode( array(
	    'plugindir' => plugin_dir_url( __DIR__ ),
	) ), 'before' );


	// nonce
	wp_nonce_field( 'backend_settings', '_gdprmapnonce' );

	// options
	$gdprmap_markers = get_post_meta( $post->ID, 'gdprmap_markers', true );

	wp_add_inline_script('gdpr-map-admin', 'var gdprmap_markers = ' . json_encode($gdprmap_markers), 'before' );

	?>

	<div id="gdprmap-main-container">

		<div class="gdprmap-style-selector">
			<div class="gdprmap-style-sel selected" data-style="osm-bright-gl-style">
				<img alt="Bright Map style" src="<?php echo plugin_dir_url( __DIR__ ); ?>img/styles/osm-bright.jpg" />
				<span>Bright</span>
			</div>
			<div class="gdprmap-style-sel" data-style="basic-gl-style">
				<img alt="Basic Map style" src="<?php echo plugin_dir_url( __DIR__ ); ?>img/styles/osm-basic.jpg" />
				<span>Basic</span>
			</div>
			<div class="gdprmap-style-sel" data-style="positron-gl-style">
				<img alt="Positron Map style" src="<?php echo plugin_dir_url( __DIR__ ); ?>img/styles/positron.jpg" />
				<span>Positron</span>
			</div>
			<div class="gdprmap-style-sel" data-style="dark-matter-gl-style">
				<img alt="Dark Matter Map style" src="<?php echo plugin_dir_url( __DIR__ ); ?>img/styles/darkmatter.jpg" />
				<span>Dark Matter</span>
			</div>
		</div>

		<div id="gdprmap-map-container">
			<div class="gdprmap-geolocation" id="gdprmap-geolocation-0">
				<input type="text" class="gdprmap-geolocation-autocomplete" onkeydown="return gdprmap_geolocation_autocomplete_enter();" onkeyup="gdprmap_geolocation_autocomplete(jQuery(this)); return false;" placeholder="In GDPR map suchen" autocomplete="off" /><button class="button button-primary button-large" onclick="gdprmap_geolocation_autocomplete();return false;">Suchen</button>
			</div>
			<div id="gdprmap-edit"></div>
		</div>

		<div id="gdprmap-marker-tbl-add">
			<button class="button button-primary button-large" onClick="gdprmap_add_marker();return false;">add marker</button>
		</div>

		<hr />

	</div>

	<div id="gdprmap-marker-tbl"></div>

	<?php

}


/**
 * save map data
 */
add_action( 'save_post_gdprmap', 'gdprmap_save_meta', 10, 2 );
function gdprmap_save_meta( $post_id, $post ) {

	// nonce check
	if ( ! isset( $_POST[ '_gdprmapnonce' ] ) || ! wp_verify_nonce( $_POST[ '_gdprmapnonce' ], 'backend_settings' ) ) {
		return $post_id;
	}

	// check current user permissions
	$post_type = get_post_type_object( $post->post_type );

	if ( ! current_user_can( $post_type->cap->edit_post, $post_id ) ) {
		return $post_id;
	}

	// Do not save the data if autosave
	if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) {
		return $post_id;
	}

	// check for gdprmap Post Type
	if( 'gdprmap' !== $post->post_type ) {
		return $post_id;
	}


	// save data
	// map data
	if( isset( $_POST[ 'gdprmap_width' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_width', sanitize_text_field( $_POST[ 'gdprmap_width' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_width' );
	}
	if( isset( $_POST[ 'gdprmap_width_unit' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_width_unit', sanitize_text_field( $_POST[ 'gdprmap_width_unit' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_width_unit' );
	}
	if( isset( $_POST[ 'gdprmap_height' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_height', sanitize_text_field( $_POST[ 'gdprmap_height' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_height' );
	}
	if( isset( $_POST[ 'gdprmap_height_unit' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_height_unit', sanitize_text_field( $_POST[ 'gdprmap_height_unit' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_height_unit' );
	}
	if( isset( $_POST[ 'gdprmap_center' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_center', sanitize_text_field( $_POST[ 'gdprmap_center' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_center' );
	}
	if( isset( $_POST[ 'gdprmap_zoom' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_zoom', sanitize_text_field( $_POST[ 'gdprmap_zoom' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_zoom' );
	}
	if( isset( $_POST[ 'gdprmap_scroll' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_scroll', sanitize_text_field( $_POST[ 'gdprmap_scroll' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_scroll' );
	}
	if( isset( $_POST[ 'gdprmap_fixed_map' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_fixed_map', sanitize_text_field( $_POST[ 'gdprmap_fixed_map' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_fixed_map' );
	}
	if( isset( $_POST[ 'gdprmap_searchbox' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_searchbox', sanitize_text_field( $_POST[ 'gdprmap_searchbox' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_searchbox' );
	}
	if( isset( $_POST[ 'gdprmap_geolocator' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_geolocator', sanitize_text_field( $_POST[ 'gdprmap_geolocator' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_geolocator' );
	}
	if( isset( $_POST[ 'gdprmap_zoom_controll' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_zoom_controll', sanitize_text_field( $_POST[ 'gdprmap_zoom_controll' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_zoom_controll' );
	}
	if( isset( $_POST[ 'gdprmap_fullscreen_controll' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_fullscreen_controll', sanitize_text_field( $_POST[ 'gdprmap_fullscreen_controll' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_fullscreen_controll' );
	}
	if( isset( $_POST[ 'gdprmap_doubleclick' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_doubleclick', sanitize_text_field( $_POST[ 'gdprmap_doubleclick' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_doubleclick' );
	}
	if( isset( $_POST[ 'gdprmap_bearing' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_bearing', sanitize_text_field( $_POST[ 'gdprmap_bearing' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_bearing' );
	}
	if( isset( $_POST[ 'gdprmap_pitch' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_pitch', sanitize_text_field( $_POST[ 'gdprmap_pitch' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_pitch' );
	}
	
	if( isset( $_POST[ 'gdprmap_style' ] ) ) {
		update_post_meta( $post_id, 'gdprmap_style', sanitize_text_field( $_POST[ 'gdprmap_style' ] ) );
	} else {
		delete_post_meta( $post_id, 'gdprmap_style' );
	}

	// marker
	$marker_arr = array();
	foreach( $_POST['gdpr-marker-name'] as $k => $v ) {

		$rev = count($_POST['gdpr-marker-name']);
		$rev--;
		$rev = $rev - $k;

		// default properties
		$marker_arr[$k]['name'] = $v;
		$marker_arr[$k]['lat'] = $_POST['gdpr-marker-lat'][$k];
		$marker_arr[$k]['lng'] = $_POST['gdpr-marker-lng'][$k];
		$marker_arr[$k]['html'] = $_POST['gdpr-marker-html'][$k];		
		$marker_arr[$k]['markercolor'] = $_POST['gdpr-marker-color'][$k];
		$marker_arr[$k]['icon'] = $_POST['gdpr-marker-icon'][$k];
		$marker_arr[$k]['defaulticon'] = $_POST['gdpr-marker-custom-icon-'.$rev];

		// geojson
		$marker_arr[$k]['geojson'] = $_POST['gdpr-marker-geojson'][$k];
		$marker_arr[$k]['usehtml'] = $_POST['gdpr-marker-use-geojson-'.$rev];
		$marker_arr[$k]['clustergeojson'] = $_POST['gdpr-marker-cluster-geojson-'.$rev];


		// cluster
		$marker_arr[$k]['geojsonactive1'] = $_POST['gdpr-marker-cluster-geojson-active-1'][$rev];
		$marker_arr[$k]['geojsonactive2'] = $_POST['gdpr-marker-cluster-geojson-active-2'][$rev];
		$marker_arr[$k]['geojsonactive3'] = $_POST['gdpr-marker-cluster-geojson-active-3'][$rev];
		$marker_arr[$k]['geojsonclustercolor1'] = $_POST['gdpr-marker-cluster-geojson-color-1'][$k];
		$marker_arr[$k]['geojsonclustercolor2'] = $_POST['gdpr-marker-cluster-geojson-color-2'][$k];
		$marker_arr[$k]['geojsonclustercolor3'] = $_POST['gdpr-marker-cluster-geojson-color-3'][$k];
		$marker_arr[$k]['geojsonradius1'] = $_POST['gdpr-marker-cluster-geojson-radius-1'][$k];
		$marker_arr[$k]['geojsonradius2'] = $_POST['gdpr-marker-cluster-geojson-radius-2'][$k];
		$marker_arr[$k]['geojsonradius3'] = $_POST['gdpr-marker-cluster-geojson-radius-3'][$k];
		$marker_arr[$k]['geojsonthreshold1'] = $_POST['gdpr-marker-cluster-geojson-threshold-1'][$k];
		$marker_arr[$k]['geojsonthreshold2'] = $_POST['gdpr-marker-cluster-geojson-threshold-2'][$k];
		$marker_arr[$k]['geojson-textcolor'] = $_POST['gdpr-marker-cluster-geojson-textcolor'][$k];
	}

	update_post_meta( $post_id, 'gdprmap_markers', $marker_arr );

	return $post_id;

}