<?php

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

/**
 *  add maps shortcode
 */
add_shortcode( 'gdprmap', 'gdprmap_shortcode' );
function gdprmap_shortcode( $atts ) {

	// check if post ist published
	if( get_post_status($atts['id']) != 'publish' ) {
		return false;
	}

	// include js and css
	gdprmap_include_js_css();

	
	// get map data
	$gdprmap_data = array (

		'gdprmap_markers' => get_post_meta( $atts['id'], 'gdprmap_markers', true ),
		'gdprmap_width' => get_post_meta( $atts['id'], 'gdprmap_width', true ),
		'gdprmap_height' => get_post_meta( $atts['id'], 'gdprmap_height', true ),
		'gdprmap_width_unit' => get_post_meta( $atts['id'], 'gdprmap_width_unit', true ),
		'gdprmap_height_unit' => get_post_meta( $atts['id'], 'gdprmap_height_unit', true ),
		'gdprmap_center' => get_post_meta( $atts['id'], 'gdprmap_center', true ),
		'gdprmap_zoom' => get_post_meta( $atts['id'], 'gdprmap_zoom', true ),
		'gdprmap_scroll' => get_post_meta( $atts['id'], 'gdprmap_scroll', true ),
		'gdprmap_fixed_map' => get_post_meta( $atts['id'], 'gdprmap_fixed_map', true ),
		'gdprmap_zoom_controll' => get_post_meta( $atts['id'], 'gdprmap_zoom_controll', true ),
		'gdprmap_fullscreen_controll' => get_post_meta( $atts['id'], 'gdprmap_fullscreen_controll', true ),
		'gdprmap_doubleclick' => get_post_meta( $atts['id'], 'gdprmap_doubleclick', true ),
		'gdprmap_bearing' => get_post_meta( $atts['id'], 'gdprmap_bearing', true ),
		'gdprmap_pitch' => get_post_meta( $atts['id'], 'gdprmap_pitch', true ),
		'gdprmap_searchbox' => get_post_meta( $atts['id'], 'gdprmap_searchbox', true ),
		'gdprmap_geolocator' => get_post_meta( $atts['id'], 'gdprmap_geolocator', true ),
		'gdprmap_style'  => get_post_meta( $atts['id'], 'gdprmap_style', true ),
	);
	
	wp_localize_script('gdpr-map', 'gdprmap_' . $atts['id'], $gdprmap_data );

	// load js and css
	wp_enqueue_script('gdpr-map-front', plugin_dir_url( __DIR__ ) . 'js/gdpr-map.js', array('jquery') );
	wp_enqueue_style('gdpr-map-front', plugin_dir_url( __DIR__ ) . 'css/style.css');

	// html output
	$html = '<div class="gdprmap-container"><div id="gdprmap-front-'.esc_attr($atts['id']).'" class="gdprmaps-front" style="width:'.esc_attr(get_post_meta( $atts['id'], 'gdprmap_width', true )).esc_attr(get_post_meta( $atts['id'], 'gdprmap_width_unit', true )).';height:'.esc_attr(get_post_meta( $atts['id'], 'gdprmap_height', true )).esc_attr(get_post_meta( $atts['id'], 'gdprmap_height_unit', true )).';" data-mid="'.esc_attr($atts['id']).'"></div></div>';


	return $html;
}


 function gdprmap_load_dashicons(){
     wp_enqueue_style('dashicons');
 }
 add_action('wp_enqueue_scripts', 'gdprmap_load_dashicons');