/*
	WooCommerce Autocomplete
*/



jQuery(document).ready(function(){

	jQuery('#billing_address_1').after('<div id="gdprmap-woocommerce-autocomplete-wrapper"></div>');

	// Keyup listener
	jQuery('#billing_address_1').on( 'keyup', function(){

		gdprmap_address_autocomplete();
		jQuery('#gdprmap-woocommerce-autocomplete-wrapper').append('<div id="gdprmap-woocommerce-autocomplete"></div>');
	});

});


function gdprmap_hervorhebenMitErhaltDerCase(text, keywords) {
	
    const keywordList = keywords.trim().split(' ');

    if( keywordList.length > 4 ) {
		return text;
	}


    // Für jedes Wort im Array, ersetze es im Text
    let hervorgehobenerText = text;
    keywordList.forEach((keyword) => {
    	const regExp = new RegExp(`(${keyword})`, 'gi');
        hervorgehobenerText = hervorgehobenerText.replace(regExp, '<b>$1</b>');        
    });



    return hervorgehobenerText;
}


function gdprmap_address_autocomplete(){

	var search = jQuery('#billing_address_1').val();

	if( search.length < 4 ) {
		return false;
	}


	var country = jQuery('#billing_country').val();

	jQuery('#gdprmap-woocommerce-autocomplete').html('<div id="lds-ring"><div class="lds-ring"><div></div><div></div><div></div><div></div></div></div>');

	jQuery.ajax({
	  url: "https://api.gdpr-map.eu/api?q="+country+", "+search+"&layer=street&layer=house&limit=7&key="+WPURLS.gdprmap_api_key,
	  dataType: 'json'
	}).done(function(data){

		var table = '<div id="gdprmap-woocommerce-autocomplete">';
		

		jQuery.each(data.features, function(k,v){

			var state = '';
			if( typeof v.properties.state != 'undefined' ) {
				state = ' '+v.properties.state+' ';
			}

			var city = '';
			if( typeof v.properties.city != 'undefined' ) {
				city = ' '+v.properties.city+' ';
			}

			var zip = '';
			if( typeof v.properties.postcode != 'undefined' ) {
				zip = v.properties.postcode;
			}

			var country = '';
			if( typeof v.properties.country != 'undefined' ) {
				country = ' '+v.properties.country+' ';
			}

			var street = ''
			var name_arr = [];
			if( typeof v.properties.name != 'undefined' ) {
				name_arr.push(v.properties.name);
				street = v.properties.name;
			}
			if( typeof v.properties.street != 'undefined' ) {
				name_arr.push(v.properties.street);
				street = v.properties.street;
			}
			if( typeof v.properties.housenumber != 'undefined' ) {
				name_arr.push(v.properties.housenumber)
				street += ' '+v.properties.housenumber;
			}

			var name = name_arr.join(' ');

			if( zip != '' || city != '' ) {

				table += '<div class="gdprmap-woocommerce-autocomplete-item" data-city="'+city+'" data-street="'+street+'" data-zip="'+zip+'" data-state="'+state+'">'+gdprmap_hervorhebenMitErhaltDerCase( name, search )+', '+zip+city'</div>';
			}else{
				table += '<div class="gdprmap-woocommerce-autocomplete-item" data-city="'+city+'" data-street="'+street+'" data-zip="'+zip+'" data-state="'+state+'">'+gdprmap_hervorhebenMitErhaltDerCase( name, search )+'</div>';
			}
			
		});

		table += '</div>';
		

		jQuery('#gdprmap-woocommerce-autocomplete-wrapper').html('');
		jQuery('#gdprmap-woocommerce-autocomplete-wrapper').append(table);

		jQuery('.gdprmap-woocommerce-autocomplete-item').click(function(){
			jQuery('#billing_address_1').val(jQuery(this).attr('data-street'));
			jQuery('#billing_postcode').val(jQuery(this).attr('data-zip'));
			jQuery('#billing_city').val(jQuery(this).attr('data-city'));
			jQuery('#billing_state').val(jQuery(this).attr('data-state'));
			jQuery('#gdprmap-woocommerce-autocomplete-wrapper').html('');
		});

	});

}