const defaultHeight = 41;
const defaultWidth = 27;

function gdprmap_create_default_marker_svg(color) {

	// create default map marker SVG
	const svg = window.document.createElementNS('http://www.w3.org/2000/svg', 'svg');
	svg.setAttributeNS(null, 'display', 'block');
	svg.setAttributeNS(null, 'height', `${defaultHeight}px`);
	svg.setAttributeNS(null, 'width', `${defaultWidth}px`);
	svg.setAttributeNS(null, 'viewBox', `0 0 ${defaultWidth} ${defaultHeight}`);

	const markerLarge = window.document.createElementNS('http://www.w3.org/2000/svg', 'g');
	markerLarge.setAttributeNS(null, 'stroke', 'none');
	markerLarge.setAttributeNS(null, 'stroke-width', '1');
	markerLarge.setAttributeNS(null, 'fill', 'none');
	markerLarge.setAttributeNS(null, 'fill-rule', 'evenodd');

	const page1 = window.document.createElementNS('http://www.w3.org/2000/svg', 'g');
	page1.setAttributeNS(null, 'fill-rule', 'nonzero');

	const shadow = window.document.createElementNS('http://www.w3.org/2000/svg', 'g');
	shadow.setAttributeNS(null, 'transform', 'translate(3.0, 29.0)');
	shadow.setAttributeNS(null, 'fill', '#000000');

	const ellipses = [
	    {'rx': '10.5', 'ry': '5.25002273'},
	    {'rx': '10.5', 'ry': '5.25002273'},
	    {'rx': '9.5', 'ry': '4.77275007'},
	    {'rx': '8.5', 'ry': '4.29549936'},
	    {'rx': '7.5', 'ry': '3.81822308'},
	    {'rx': '6.5', 'ry': '3.34094679'},
	    {'rx': '5.5', 'ry': '2.86367051'},
	    {'rx': '4.5', 'ry': '2.38636864'}
	];

	for (const data of ellipses) {
	    const ellipse = window.document.createElementNS('http://www.w3.org/2000/svg', 'ellipse');
	    ellipse.setAttributeNS(null, 'opacity', '0.04');
	    ellipse.setAttributeNS(null, 'cx', '10.5');
	    ellipse.setAttributeNS(null, 'cy', '5.80029008');
	    ellipse.setAttributeNS(null, 'rx', data['rx']);
	    ellipse.setAttributeNS(null, 'ry', data['ry']);
	    shadow.appendChild(ellipse);
	}

	const background = window.document.createElementNS('http://www.w3.org/2000/svg', 'g');
	background.setAttributeNS(null, 'fill', color);

	const bgPath = window.document.createElementNS('http://www.w3.org/2000/svg', 'path');
	bgPath.setAttributeNS(null, 'd', 'M27,13.5 C27,19.074644 20.250001,27.000002 14.75,34.500002 C14.016665,35.500004 12.983335,35.500004 12.25,34.500002 C6.7499993,27.000002 0,19.222562 0,13.5 C0,6.0441559 6.0441559,0 13.5,0 C20.955844,0 27,6.0441559 27,13.5 Z');

	background.appendChild(bgPath);

	const border = window.document.createElementNS('http://www.w3.org/2000/svg', 'g');
	border.setAttributeNS(null, 'opacity', '0.25');
	border.setAttributeNS(null, 'fill', '#000000');

	const borderPath = window.document.createElementNS('http://www.w3.org/2000/svg', 'path');
	borderPath.setAttributeNS(null, 'd', 'M13.5,0 C6.0441559,0 0,6.0441559 0,13.5 C0,19.222562 6.7499993,27 12.25,34.5 C13,35.522727 14.016664,35.500004 14.75,34.5 C20.250001,27 27,19.074644 27,13.5 C27,6.0441559 20.955844,0 13.5,0 Z M13.5,1 C20.415404,1 26,6.584596 26,13.5 C26,15.898657 24.495584,19.181431 22.220703,22.738281 C19.945823,26.295132 16.705119,30.142167 13.943359,33.908203 C13.743445,34.180814 13.612715,34.322738 13.5,34.441406 C13.387285,34.322738 13.256555,34.180814 13.056641,33.908203 C10.284481,30.127985 7.4148684,26.314159 5.015625,22.773438 C2.6163816,19.232715 1,15.953538 1,13.5 C1,6.584596 6.584596,1 13.5,1 Z');

	border.appendChild(borderPath);

	const maki = window.document.createElementNS('http://www.w3.org/2000/svg', 'g');
	maki.setAttributeNS(null, 'transform', 'translate(6.0, 7.0)');
	maki.setAttributeNS(null, 'fill', '#FFFFFF');

	const circleContainer = window.document.createElementNS('http://www.w3.org/2000/svg', 'g');
	circleContainer.setAttributeNS(null, 'transform', 'translate(8.0, 8.0)');

	const circle1 = window.document.createElementNS('http://www.w3.org/2000/svg', 'circle');
	circle1.setAttributeNS(null, 'fill', '#000000');
	circle1.setAttributeNS(null, 'opacity', '0.25');
	circle1.setAttributeNS(null, 'cx', '5.5');
	circle1.setAttributeNS(null, 'cy', '5.5');
	circle1.setAttributeNS(null, 'r', '5.4999962');

	const circle2 = window.document.createElementNS('http://www.w3.org/2000/svg', 'circle');
	circle2.setAttributeNS(null, 'fill', '#FFFFFF');
	circle2.setAttributeNS(null, 'cx', '5.5');
	circle2.setAttributeNS(null, 'cy', '5.5');
	circle2.setAttributeNS(null, 'r', '5.4999962');

	circleContainer.appendChild(circle1);
	circleContainer.appendChild(circle2);

	page1.appendChild(shadow);
	page1.appendChild(background);
	page1.appendChild(border);
	page1.appendChild(maki);
	page1.appendChild(circleContainer);

	svg.appendChild(page1);

	svg.setAttributeNS(null, 'height', `${defaultHeight}px`);
	svg.setAttributeNS(null, 'width', `${defaultWidth}px`);


	// Generate PNG from SVG
	const svgData = new XMLSerializer().serializeToString(svg);
	const svgBlob = new Blob([svgData], { type: 'image/svg+xml;charset=utf-8' });
	const svgUrl = URL.createObjectURL(svgBlob);

	return {url: svgUrl, svg: svgData};
}



async function createImageBitmapFromSVG(svgUrl) {
    return new Promise((resolve, reject) => {
        const img = new Image();
        img.src = svgUrl;

        img.onload = async () => {
            const canvas = document.createElement('canvas');
            canvas.width = defaultWidth;
            canvas.height = defaultHeight;

            const context = canvas.getContext('2d');
            context.drawImage(img, 0, 0);

            // Konvertiere das Canvas zu einem ImageBitmap
            try {
                const imageBitmap = await createImageBitmap(canvas);
                resolve(imageBitmap);
            } catch (error) {
                reject(error);
            }

            URL.revokeObjectURL(svgUrl);
        };

        img.onerror = (error) => {
            reject(error);
        };
    });
}


function gdprmap_create_default_marker(layerid, source, color, minzoom, currmap) {

	
	// create marker svg
	svgUrl = gdprmap_create_default_marker_svg(color).url;

	// generate Bitmap
	createImageBitmapFromSVG(svgUrl).then(imageBitmap => {
	    
	    if( currmap.getImage('M'+layerid) ) {
			currmap.removeImage('M'+layerid);
		}

		currmap.addImage('M'+layerid, imageBitmap);

		currmap.addLayer({
		    'id': layerid,
		    'type': 'symbol',
		    'source': source,
		    'layout': {
		        'icon-image': 'M'+layerid,
		        'icon-size': 1, // Größe des Icons
		        'icon-anchor': 'bottom'
		    },
		    'minzoom': minzoom
		});

	}).catch(error => {
	    console.error('Fehler beim Erstellen des ImageBitmap:', error);
	});
}



async function gdprmap_create_custom_marker(layerid, source, url, minzoom, currmap) {

	const image = await currmap.loadImage(url);
	
	if( currmap.getImage('M'+layerid) ) {
		currmap.removeImage('M'+layerid);
	}

	currmap.addImage('M'+layerid, image.data);

	currmap.addLayer({
	    'id': layerid,
	    'type': 'symbol',
	    'source': source,
	    'layout': {
	        'icon-image': 'M'+layerid,
	        'icon-size': 1, // Größe des Icons
	        'icon-anchor': 'bottom'
	    },
	    'minzoom': minzoom
	});

}


async function gdprmap_update_custom_marker(layerid, url, minzoom) {

	const image = await map.loadImage(url);
	
	if( map.getImage('M'+layerid) ) {
		map.removeImage('M'+layerid);
	}

	map.addImage('M'+layerid, image.data);

	map.redraw();

}


function gdprmap_create_default_svg_logo() {

	return '<svg\
   version="1.1"\
   id="Ebene_1"\
   x="0px"\
   y="0px"\
   width="136.06984"\
   height="30.481428"\
   viewBox="0 0 136.06984 30.481428"\
   enable-background="new 0 0 250 50"\
   xml:space="preserve"\
   sodipodi:docname="GDPR.svg"\
   inkscape:version="1.1.2 (0a00cf5339, 2022-02-04)"\
   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"\
   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"\
   xmlns="http://www.w3.org/2000/svg"\
   xmlns:svg="http://www.w3.org/2000/svg"><defs\
   id="defs13" /><sodipodi:namedview\
   id="namedview11"\
   pagecolor="#ffffff"\
   bordercolor="#666666"\
   borderopacity="1.0"\
   inkscape:pageshadow="2"\
   inkscape:pageopacity="0.0"\
   inkscape:pagecheckerboard="0"\
   showgrid="false"\
   inkscape:zoom="2.5602093"\
   inkscape:cx="127.13804"\
   inkscape:cy="56.2454"\
   inkscape:window-width="1920"\
   inkscape:window-height="1168"\
   inkscape:window-x="1920"\
   inkscape:window-y="0"\
   inkscape:window-maximized="1"\
   inkscape:current-layer="Ebene_1" />\
<g\
   aria-label="GDPR "\
   transform="translate(-1.4423828,25.535156)"\
   id="text6"><path\
     d="m 26.529297,-20.320312 -1.892578,1.792968 q -2.041992,-2.008789 -4.482422,-3.038086 -2.423828,-1.045898 -4.731445,-1.045898 -2.872071,0 -5.4785161,1.411133 -2.5898437,1.411133 -4.0175781,3.834961 -1.4277344,2.407226 -1.4277344,5.096679 0,2.7558597 1.4775391,5.2460941 1.4775391,2.4736328 4.0839845,3.9013671 2.606445,1.4111329 5.710937,1.4111329 3.768555,0 6.375,-2.125 2.606446,-2.125 3.087891,-5.5117188 h -7.786133 v -2.3574223 h 10.525391 q -0.0332,5.6611333 -3.370117,8.9980473 -3.320313,3.32031251 -8.898438,3.32031251 -6.7734374,0 -10.7246093,-4.61523441 -3.0380859,-3.5527343 -3.0380859,-8.2177734 0,-3.469727 1.7431641,-6.458008 1.743164,-2.988281 4.78125,-4.665039 3.0380861,-1.693359 6.8730471,-1.693359 3.104492,0 5.84375,1.128906 2.739258,1.112305 5.345703,3.585938 z"\
     style="font-size:34px;font-family:CenturyGothic;letter-spacing:-2;stroke:#000000;stroke-miterlimit:10"\
     id="path15" /><path\
     d="m 30.62207,0 v -24.420898 h 5.063477 q 5.478515,0 7.952148,0.879882 3.552735,1.245118 5.544922,4.316407 2.008789,3.071289 2.008789,7.321289 0,3.668945 -1.59375,6.4580075 Q 48.020508,-2.65625 45.480469,-1.328125 42.957031,0 38.391602,0 Z m 2.340821,-2.3076172 h 2.822265 q 5.063477,0 7.022461,-0.6308594 2.75586,-0.8964843 4.333008,-3.2207031 1.577148,-2.3408203 1.577148,-5.7109373 0,-3.536133 -1.709961,-6.042969 -1.70996,-2.506836 -4.764648,-3.436523 -2.291016,-0.697266 -7.553711,-0.697266 h -1.726562 z"\
     style="font-size:34px;font-family:CenturyGothic;letter-spacing:-2;stroke:#000000;stroke-miterlimit:10"\
     id="path17" /><path\
     d="m 53.90625,-24.420898 h 4.864258 q 4.183594,0 5.644531,0.365234 2.091797,0.514648 3.419922,2.125 1.328125,1.59375 1.328125,4.017578 0,2.44043 -1.294922,4.03418 -1.294922,1.577148 -3.569336,2.125 -1.660156,0.398437 -6.208984,0.398437 H 56.34668 V 0 h -2.44043 z m 2.44043,2.374023 v 8.300781 l 4.133789,0.0498 q 2.506836,0 3.668945,-0.448242 1.162109,-0.464844 1.826172,-1.477539 0.664062,-1.029297 0.664062,-2.291016 0,-1.228516 -0.664062,-2.241211 -0.664063,-1.029297 -1.759766,-1.460937 -1.079101,-0.431641 -3.552734,-0.431641 z"\
     style="font-size:34px;font-family:CenturyGothic;letter-spacing:-2;stroke:#000000;stroke-miterlimit:10"\
     id="path19" /><path\
     d="m 72.176758,-24.420898 h 4.864258 q 4.067382,0 5.511718,0.332031 2.174805,0.498047 3.536133,2.141601 1.361328,1.626954 1.361328,4.017579 0,1.992187 -0.946289,3.502929 -0.929687,1.510742 -2.672851,2.291016 -1.743164,0.763672 -4.814453,0.780273 L 87.798828,0 H 84.777344 L 76.011719,-11.355469 H 74.617187 V 0 h -2.440429 z m 2.440429,2.390625 v 8.300781 l 4.200196,0.0332 q 2.440429,0 3.602539,-0.464844 1.178711,-0.464844 1.826172,-1.477539 0.664062,-1.029297 0.664062,-2.291015 0,-1.228516 -0.664062,-2.22461 -0.664063,-1.012695 -1.743164,-1.444336 -1.079102,-0.43164 -3.585938,-0.43164 z"\
     style="font-size:34px;font-family:CenturyGothic;letter-spacing:-2;stroke:#000000;stroke-miterlimit:10"\
     id="path21" /></g>\
<g\
   aria-label="map"\
   transform="translate(88.396017,25.905256)"\
   id="text8"\
   style="font-size:22px;font-family:ArialMT;fill:#1b1f22"><path\
     d="m 11.44043,-9.7216797 q 0.741211,-1.3320313 1.772461,-1.9658203 1.03125,-0.633789 2.427734,-0.633789 1.879883,0 2.900391,1.321289 1.020507,1.3105469 1.020507,3.7382813 V 0 h -1.987304 v -7.1972656 q 0,-1.7294922 -0.612305,-2.5673828 -0.612305,-0.8378906 -1.869141,-0.8378906 -1.536132,0 -2.427734,1.0205077 -0.891601,1.0205079 -0.891601,2.7822266 V 0 H 9.7861328 v -7.1972656 q 0,-1.7402344 -0.6123047,-2.5673828 -0.6123047,-0.8378906 -1.890625,-0.8378906 -1.5146484,0 -2.40625,1.0312499 -0.8916015,1.0205078 -0.8916015,2.7714844 V 0 H 1.9980469 v -12.03125 h 1.9873047 v 1.869141 q 0.6767578,-1.106446 1.6220703,-1.632813 0.9453125,-0.526367 2.2451172,-0.526367 1.3105468,0 2.2236329,0.666016 Q 11,-10.989258 11.44043,-9.7216797 Z"\
     id="path42" /><path\
     d="m 28.97168,-6.0478516 q -2.395508,0 -3.319336,0.5478516 -0.923828,0.5478516 -0.923828,1.8691406 0,1.0527344 0.6875,1.6757813 0.698242,0.6123047 1.890625,0.6123047 1.643554,0 2.631836,-1.1601563 0.999023,-1.1708984 0.999023,-3.1044922 v -0.4404297 z m 3.942382,-0.8164062 V 0 H 30.9375 v -1.8261719 q -0.676758,1.09570315 -1.686523,1.62207034 -1.009766,0.515625 -2.470704,0.515625 -1.847656,0 -2.943359,-1.03125 -1.084961,-1.04199214 -1.084961,-2.78222654 0,-2.0302735 1.353516,-3.0615235 1.364258,-1.03125 4.060547,-1.03125 H 30.9375 v -0.1933593 q 0,-1.3642579 -0.902344,-2.1054688 -0.891601,-0.7519533 -2.513672,-0.7519533 -1.03125,0 -2.008789,0.24707 -0.977539,0.247071 -1.879883,0.7412114 v -1.8261714 q 1.084961,-0.418946 2.105469,-0.623047 1.020508,-0.214844 1.987305,-0.214844 2.610351,0 3.899414,1.353516 1.289062,1.3535152 1.289062,4.1035152 z"\
     id="path44" /><path\
     d="M 38.897461,-1.8046875 V 4.5761719 H 36.910156 V -12.03125 h 1.987305 v 1.826172 q 0.623047,-1.074219 1.568359,-1.589844 0.956055,-0.526367 2.277344,-0.526367 2.191406,0 3.555664,1.740234 1.375,1.7402347 1.375,4.5761722 0,2.8359375 -1.375,4.5761719 -1.364258,1.74023434 -3.555664,1.74023434 -1.321289,0 -2.277344,-0.515625 -0.945312,-0.52636719 -1.568359,-1.60058594 z m 6.724609,-4.2001953 q 0,-2.1806641 -0.902343,-3.4160156 -0.891602,-1.2460936 -2.459961,-1.2460936 -1.56836,0 -2.470704,1.2460936 -0.891601,1.2353515 -0.891601,3.4160156 0,2.180664 0.891601,3.4267578 0.902344,1.2353516 2.470704,1.2353516 1.568359,0 2.459961,-1.2353516 0.902343,-1.2460938 0.902343,-3.4267578 z"\
     id="path46" /></g>\
</svg>';

}


function gdprmap_create_default_svg_marker() {

	return '<?xml version="1.0" encoding="UTF-8" standalone="no"?>\
<svg\
   class="svg-icon"\
   style="width: 1em; height: 1em;vertical-align: middle;fill: currentColor;overflow: hidden;"\
   viewBox="0 0 1024 1024"\
   version="1.1"\
   xmlns="http://www.w3.org/2000/svg"\
   xmlns:svg="http://www.w3.org/2000/svg">  \
  <path\
     d="M554.666053 0c-188.199961 0-341.328427 153.128465-341.328426 341.328427 0 181.096063 310.310206 653.067945 323.536682 673.078324a21.269028 21.269028 0 0 0 35.583489 0C585.684274 994.396372 895.99448 522.42449 895.99448 341.328427c0-188.199961-153.128465-341.328427-341.328427-341.328427z m0 963.378151C487.829681 858.952986 256.00368 486.201011 256.00368 341.328427c0-164.690966 133.971407-298.662373 298.662373-298.662374s298.662373 133.971407 298.662374 298.662374c0 144.829918-231.826001 517.624559-298.662374 622.049724z"\
     fill="#010101"\
     id="path51"\
     style="fill:#808080;fill-opacity:1" />\
  <path\
     d="M554.666053 191.99724c-82.32415 0-149.331187 66.985704-149.331186 149.331187s67.007037 149.331187 149.331186 149.331186 149.331187-66.985704 149.331187-149.331186-67.007037-149.331187-149.331187-149.331187z m0 255.99632c-58.815155 0-106.665133-47.849979-106.665133-106.665133s47.849979-106.665133 106.665133-106.665134 106.665133 47.849979 106.665134 106.665134-47.849979 106.665133-106.665134 106.665133z"\
     fill="#010101"\
     id="path53"\
     style="fill:#808080;fill-opacity:1" />\
</svg>\
';
}