/* Search and Autocomplete */
function gdprmap_hervorhebenMitErhaltDerCase(text, keywords) {
	
    const keywordList = keywords.replace(/[^a-zA-ZäöüÄÖÜß\s0-9]/g, '').replace(/\s+/g, ' ').trim().split(' ');
    

    // Für jedes Wort im Array, ersetze es im Text
    let hervorgehobenerText = text;
    keywordList.forEach((keyword) => {
    	const regExp = new RegExp(`(${keyword})`, 'gi');
        hervorgehobenerText = hervorgehobenerText.replace(regExp, '<b>$1</b>');        
    });



    return hervorgehobenerText;
}


var autocomplete_marker = 'unset';
var autocomplete_txt = '';
var xhr = null;
function gdprmap_geolocation_autocomplete(element) {


	if( xhr !== null ) {
		xhr.abort();
	}

	var search = element.val();

	if( search.length < 3 ) {
		return false;
	}

	// if Text is the same
	if( autocomplete_txt == search ) {
		jQuery(element).parent().find('.gdprmap-geolocation-autocomplete-tbl').css('display', 'block');
		element.addClass('open');
		return false;
	}

	// update text if not the same
	autocomplete_txt = search;

	jQuery(element).parent().find('.gdprmap-geolocation-autocomplete-tbl').html('<div class="gdprmap-geolocation-autocomplete-tbl-poweredby">Powered by '+gdprmap_create_default_svg_logo()+'</div>');

	xhr = jQuery.ajax({
	  url: "https://api.gdpr-map.eu/api?q="+encodeURIComponent(search)+"&layer=street&layer=city&layer=house&lang=de&limit=5&key="+WPURLS.gdprmap_api_key,
	  dataType: 'json'
	}).done(function(data){

		xhr = null;

		var table = '<div class="gdprmap-geolocation-autocomplete-tbl">';
		
		var dedup = [];
		jQuery.each(data.features, function(k,v){

			var state = '';
			if( typeof v.properties.state != 'undefined' ) {
				state = ' '+v.properties.state+' ';
			}

			var city = '';
			if( typeof v.properties.city != 'undefined' ) {
				city = ' '+v.properties.city+' ';
			}

			var country = '';
			if( typeof v.properties.country != 'undefined' ) {
				country = ' '+v.properties.country+' ';
			}

			var name_arr = [];
			if( typeof v.properties.name != 'undefined' ) {
				name_arr.push(v.properties.name);
			}
			if( typeof v.properties.street != 'undefined' ) {
				name_arr.push(v.properties.street);
			}
			if( typeof v.properties.housenumber != 'undefined' ) {
				name_arr.push(v.properties.housenumber)
			}

			var postcode = '';
			if( typeof v.properties.postcode != 'undefined' ) {
				postcode = ' '+v.properties.postcode+' ';
			}
			

			var name = name_arr.join(' ');


			if( postcode != '' || city != '' ) {

				if( !dedup.includes(name+postcode+city) ) {

					table += '<div class="gdprmap-geolocation-autocomplete-tbl-item" data-lat="'+v.geometry.coordinates[1]+'" data-lon="'+v.geometry.coordinates[0]+'">'+gdprmap_create_default_svg_marker()+'<span>'+gdprmap_hervorhebenMitErhaltDerCase( name, element.val() )+', '+postcode+city+'</span></div>';
					dedup.push(name+postcode+city);
				}

			}else{

				if( !dedup.includes(name) ) {

					table += '<div class="gdprmap-geolocation-autocomplete-tbl-item" data-lat="'+v.geometry.coordinates[1]+'" data-lon="'+v.geometry.coordinates[0]+'">'+gdprmap_create_default_svg_marker()+'<span>'+gdprmap_hervorhebenMitErhaltDerCase( name, element.val() )+'</span></div>';
					dedup.push(name);
				}
			}
			
		});


		// Powered by GDPR map
		table += '<div class="gdprmap-geolocation-autocomplete-tbl-poweredby">Powered by '+gdprmap_create_default_svg_logo()+'</div>';


		element.addClass('open');

		jQuery(element).parent().find('.gdprmap-geolocation-autocomplete-tbl').remove();
		jQuery(element).parent().append(table);

		jQuery(element).parent().find('.gdprmap-geolocation-autocomplete-tbl-item').click(function(){

			jQuery(this).parent().parent().find('input').val(jQuery(this).text().replace(/\s+/g, ' ').trim());

			var lat = jQuery(this).attr("data-lat");
			var lon = jQuery(this).attr("data-lon");

			var center = [ [parseFloat(lon)], [parseFloat(lat)] ];

			if( autocomplete_marker != 'unset' ) {
				autocomplete_marker.remove();
			}

			// get map ID
			var mapID = parseInt(jQuery(this).parent().parent().attr('id').replace('gdprmap-geolocation-', ''));

			gdprmap_all_maps[mapID].setCenter(center);
			gdprmap_all_maps[mapID].setZoom(13);

			jQuery(this).parent().css('display', 'none');
			jQuery(this).parent().removeClass('open');

		});

		// Geocoder focus listener
		jQuery('.gdprmap-geolocation-autocomplete').off('focus');
		jQuery('.gdprmap-geolocation-autocomplete').on( "focus", function() {

			jQuery(this).parent().find('.gdprmap-geolocation-autocomplete-tbl').css('display', 'block');
			jQuery(this).select();

			if( jQuery(this).parent().find('.gdprmap-geolocation-autocomplete-tbl').length != 0 ) {
				jQuery(this).parent().find('.gdprmap-geolocation-autocomplete').addClass('open');
			}
		});
	});

	return false;

}



/**
 * geolocation autocomplete ENTER
*/
function gdprmap_geolocation_autocomplete_enter() {
	if(event.keyCode == 13) {
		if( jQuery(this).parent().find('.gdprmap-geolocation-autocomplete').hasClass('open') ) {
			jQuery(this).parent().find('.gdprmap-geolocation-autocomplete-tbl .gdprmap-geolocation-autocomplete-tbl-item:first-child').click();
			jQuery(this).parent().find('.gdprmap-geolocation-autocomplete').blur();
		}else{

			jQuery( document ).on( "ajaxComplete", null, gdprmap_geolocation_autocomplete_enter_ajaxlistener );
			jQuery(this).parent().find('.gdprmap-geolocation-autocomplete').blur();
		}
        return false;
    }
}

function gdprmap_geolocation_autocomplete_enter_ajaxlistener() {
	jjQuery(this).parent().find('.gdprmap-geolocation-autocomplete-tbl .gdprmap-geolocation-autocomplete-tbl-item:first-child').click();
	jQuery( document ).off( "ajaxComplete", null, gdprmap_geolocation_autocomplete_enter_ajaxlistener );
}
